<script>
import { GlLabel } from '@gitlab/ui'
import DataTable from '@/mixins/data-table'
import LocalStorage from '@/mixins/local-storage'
import getDataManifest from '@/assets/get-data-manifest'

export default {
  name: 'SnowplowPage',

  mixins: [DataTable, LocalStorage],

  async asyncData() {
    return { dataManifest: await getDataManifest() }
  },

  data() {
    return {
      namespace: 'snowplow',
      paginationLimit: 15,
      columns: [
        {
          id: 'web_path',
          name: 'Web Path',
          hidden: true,
          nonConfigurable: true,
        },
        {
          id: 'key',
          name: 'Key',
          hidden: false,
          formatter: (cell, row) => {
            const htmlLink = `<a
                href="${row.cells[0].data}"
                target="_blank"
                rel="noopener"
                class="ml-2"
              >${cell}</a>`

            const nuxtLink = `<a
                href="/keys/snowplow?q=${row.cells[1].data}"
                rel="noopener"
                class="${this.getCellButtonClasses()}"
              >↗</a>`

            return this.$gridjs.html(
              `<div><div class="whitespace-nowrap">${
                nuxtLink + htmlLink
              }</div></div>`
            )
          },
        },
        {
          id: 'description',
          name: 'Description',
          hidden: true,
          width: '400px',
        },
        {
          id: 'action',
          name: 'Action',
          hidden: false,
          formatter: (cell) =>
            this.$gridjs.html(`<span class="font-mono">${cell}</span>`),
        },
        {
          id: 'category',
          name: 'Category',
          hidden: false,
          formatter: (cell) =>
            this.wrapCellWithMono(this.interpretVariables(cell)),
        },
        {
          id: 'label_description',
          name: 'Label description',
          hidden: false,
          formatter: (cell) =>
            this.wrapCellWithMono(this.interpretVariables(cell)),
        },
        {
          id: 'property_description',
          name: 'Property description',
          hidden: true,
          formatter: (cell) =>
            this.wrapCellWithMono(this.interpretVariables(cell)),
        },
        {
          id: 'value_description',
          name: 'Value description',
          hidden: true,
          formatter: (cell) =>
            this.wrapCellWithMono(this.interpretVariables(cell)),
        },
        {
          id: 'extra_properties',
          name: 'Extra properties',
          hidden: true,
          width: '400px',
          data: (data) =>
            data.extra_properties ? JSON.stringify(data.extra_properties) : '',
          formatter: (extraJson) => {
            if (!extraJson) {
              return ''
            }

            const content = []
            const properties = JSON.parse(extraJson)
            const keys = Object.keys(properties)

            keys.forEach((key) => {
              try {
                content.push(
                  `<b>${key}:</b> ${JSON.stringify(properties[key])}`
                )
              } catch (e) {
                /* */
              }
            })

            return this.$gridjs.html(
              `<span class="font-mono">${content.join('<br>')}</span>`
            )
          },
        },
        {
          id: 'distribution',
          name: 'Distribution',
          hidden: true,
        },
        { id: 'identifiers', name: 'Identifiers', hidden: true },
        {
          id: 'introduced_by_url',
          name: 'Introduced by URL',
          hidden: true,
          data: (data) => data.introduced_by_url || '',
          formatter: (cell) => {
            if (!cell) {
              return ''
            }

            return this.$gridjs.html(
              cell
                ? `<a
                href="${cell}"
                target="_blank"
                rel="noopener"
                class="text-center"
              >${cell}</div>`
                : ''
            )
          },
        },
        {
          id: 'product_stage',
          name: 'Stage',
          hidden: false,
          formatter: (cell) => {
            if (!cell) {
              return ''
            }

            const current = this.$gridjs.uuid()
            this.$gridjs.render(`[data-ref="${current}"]`, GlLabel, {
              backgroundColor: '#F0AD4E',
              title: `devops::${cell}`,
              scoped: true,
            })

            return this.$gridjs.html(`<div data-ref="${current}"></div>`)
          },
        },
        {
          id: 'product_section',
          name: 'Section',
          hidden: false,
          formatter: (cell) => {
            if (!cell) {
              return ''
            }

            const current = this.$gridjs.uuid()
            this.$gridjs.render(`[data-ref="${current}"]`, GlLabel, {
              backgroundColor: '#F0AD4E',
              title: `section::${cell}`,
              scoped: true,
            })

            return this.$gridjs.html(`<div data-ref="${current}"></div>`)
          },
        },
        {
          id: 'product_group',
          name: 'Group',
          hidden: false,
          formatter: (cell) => {
            if (!cell) {
              return ''
            }

            const current = this.$gridjs.uuid()
            this.$gridjs.render(`[data-ref="${current}"]`, GlLabel, {
              backgroundColor: '#6366F1',
              title: cell,
              scoped: true,
            })

            return this.$gridjs.html(`<div data-ref="${current}"></div>`)
          },
        },
        {
          id: 'tier',
          name: 'Tier',
          hidden: true,
        },
        { id: 'milestone', name: 'Milestone', hidden: false },
      ],
      dataUrl: '',
      sharePath: '',
    }
  },

  head() {
    return {
      title: 'Snowplow',
    }
  },

  created() {
    this.dataUrl = new URL(
      `data/snowplow.${this.dataManifest.snowplow}.json`,
      location.origin
    ).toString()
  },

  methods: {
    wrapCellWithMono(cell) {
      if (typeof cell !== 'string') {
        return cell
      }
      const hasWhiteSpace = /\s/.test(cell)

      if (hasWhiteSpace) {
        return this.$gridjs.html(`<em>${cell}</em>`)
      }

      return this.$gridjs.html(`<div class="font-mono">${cell}</div>`)
    },
  },
}
</script>

<template>
  <div class="px-4 sm:px-6 lg:px-8">
    <md-table-config
      :columns="columns"
      :namespace="namespace"
      :pagination-limit="paginationLimit"
      :share-path="sharePath"
      export-path="/data/snowplow.csv"
      @search="handleSearch"
      @columns-change="handleColumnsChange"
      @pagination-limit-change="handlePaginationLimitChange"
    />

    <md-table
      ref="table"
      :columns="columns"
      :data-url="dataUrl"
      :pagination-limit="paginationLimit"
      @loaded-rows="buildSharePath"
    />
  </div>
</template>
